//=================================================================================================
//  Copyright (C) 2013 Nuvoton(SH) Technology Corp. All rights reserved 
//=================================================================================================
#include "nano1xx.h"
extern void Lcd_ShowNum(uint32_t adress, uint32_t Data);
extern void DataFlashTest(void);
uint32_t g_u32hiMin,g_u32loMin,g_u32hiSec,g_u32loSec ;

void UnlockReg(void)
{
  while((GCR->RegLockAddr & 1) == 0){                      // ֹϽɹ
    GCR->RegLockAddr = 0x59 ; 
    GCR->RegLockAddr = 0x16 ; 
    GCR->RegLockAddr = 0x88 ;
  }
} 
void delay(void)
{
  uint32_t i;
  for(i=0;i<40000;i++);
}

void RTC_IRQHandler()
{
	/* RTC Tick interrupt */
	if (RTC->RIIR & RTC_RIIR_TIS)		
	{
		RTC->RIIR   = RTC_RIIR_TIS;
		g_u32hiMin  =  ((RTC->TLR & RTC_TLR_TEN_MIN) >> 12)&0x0F;
		g_u32loMin  =  ((RTC->TLR & RTC_TLR_MIN) >> 8)&0x0F;
		g_u32hiSec  =  ((RTC->TLR & RTC_TLR_TEN_SEC) >> 4)&0x0F;
		g_u32loSec  =  (RTC->TLR & RTC_TLR_SEC)&0x0F;

		Lcd_ShowNum(4,g_u32loSec) ;
		Lcd_ShowNum(3,g_u32hiSec) ;

		Lcd_ShowNum(1,g_u32loMin) ;
		Lcd_ShowNum(0,g_u32hiMin) ;
  }
}
void SysClkInit(void)
{
  UnlockReg() ;                        // ֻ HIRC=12MHz 32768
  CLK->PWRCTL  |=  CLK_PWRCTL_HIRC_EN | CLK_PWRCTL_LXT_EN ; 
	CLK->PWRCTL  &=  ~(CLK_PWRCTL_LIRC_EN | CLK_PWRCTL_HXT_EN) ; 
  while((CLK->CLKSTATUS & CLK_CLKSTATUS_LXT_STB) == 0);	        
  LOCKREG() ;                                              
}                       

/////////////////////////////////////////////////////////////////////////////////////////
int32_t main(void)							   
{   
  SysClkInit() ;
	
//  DataFlashTest();
		
  CLK->APBCLK  |= CLK_APBCLK_LCD_EN ;           // LCD ʱʹ ĬʱԴ32768
  LCD->CTL     = LCD_CTL_PDDISP_EN|LCD_CTL_EN|6|0x30;    // 4-MUX | LCDʱ128Ƶ 

	LCD->DISPCTL  = LCD_DISPCTL_CPUMP_EN|4 ;      //  1/3ƫѹ                   
//  | 0x60010|LCD_DISPCTL_BV_SEL    // ڲ400KʹܺR-Type
							
	GCR->PB_L_MFP = (GCR->PB_L_MFP &~(0xFFF00000)) | (0x88800000);  /* seg 35 ~ 33 */\
  GCR->PB_H_MFP = 0x88888888;   /* seg 32 ~ 31, 28 ~ 23 */\
  GCR->PC_L_MFP = 0x88808888;   /* seg 22 ~ 15 */\
  GCR->PC_H_MFP = 0x88888888;   /* seg 14 ~ 7 */\
  GCR->PD_L_MFP = 0x88888888;   /* seg 6 ~ 0, COM3 */\
  GCR->PD_H_MFP = 0x88800888;   /* COM2 ~ 0, DH2 ~ 1, V3 ~1 */\
  GCR->PE_H_MFP = (GCR->PE_H_MFP &~(0x000000FF)) | (0x00000088);   /* seg 30, 29 */\
  
	
//	GCR->PF_L_MFP &=0xFF00FFFF;  // ICEΪGPIOģʽ
//	GPIOF->PUEN |=0x30;          //ʹ ICE 
	  	
	GPIOA->OFFD |= 0xFFFF0000;
	GPIOB->OFFD |= 0xFFFF0000;
	GPIOC->OFFD |= 0xFFFF0000;
	GPIOD->OFFD |= 0xFFFF0000;
	GPIOE->OFFD |= 0xFFFF0000;
//	GPIOF->OFFD |= 0xFFCF0000;  //ICE: PF4 PF5ʹܹܲ

//================RTC=============================================	
	CLK->APBCLK |= CLK_APBCLK_RTC_EN;	

	RTC->INIR = 0xA5EB1357;			//λRTC
	while((RTC->INIR&0x1) == 0x0); 	
	RTC->AER = 0xA965;
	while((RTC->AER&RTC_AER_ENF) == 0x0); //ʹRTCĴ

	RTC->CLR=0x140409;	 //ʼǰ
	RTC->DWR=0x03;		 //ʼǰ
	RTC->TSSR=0x01;	     //24Сʱ
	RTC->TLR=0x000000;	 //ʼǰʱ
	RTC->TTR =	RTC_TTR_TWKE|0;  //Tick one second
	RTC->RIER |= RTC_RIER_TIER; 	
	NVIC->ISER[0] = (1 << (RTC_IRQn & 0x1F)); 
	RTC->AER = 0;

	delay();    //ҪʱRTCʱӣֵ60uS

	g_u32hiMin  =  ((RTC->TLR & RTC_TLR_TEN_MIN) >> 12)&0x0F;
	g_u32loMin  =  ((RTC->TLR & RTC_TLR_MIN) >> 8)&0x0F;
	g_u32hiSec  =  ((RTC->TLR & RTC_TLR_TEN_SEC) >> 4)&0x0F;
	g_u32loSec  =  (RTC->TLR & RTC_TLR_SEC)&0x0F;
    
	Lcd_ShowNum(4,g_u32loSec) ;
	Lcd_ShowNum(3,g_u32hiSec) ;
	
	Lcd_ShowNum(1,g_u32loMin) ;
	Lcd_ShowNum(0,g_u32hiMin) ;
	
	while(1)
	{															
		UnlockReg() ;
		CLK->PWRCTL |= CLK_PWRCTL_PWRDOWN_EN ;               // ߹ʹλ,Զ 
		SCB->SCR    |= 0x04 ;                                // ģʽ
		LOCKREG() ;                                   			
		__wfi() ;                                            // ״̬      
	} 
    
}
